/// A **country**, identified according to
/// [ISO 3166](https://www.iso.org/iso-3166-country-codes.html).
///
enum Country {
  /// Afghanistan
  afghanistan(
    alpha2Code: 'AF',
    alpha3Code: 'AFG',
    englishName: 'Afghanistan',
    flagEmoji: '🇦🇫',
    numericCode: '004',
  ),

  /// Åland Islands
  alandIslands(
    alpha2Code: 'AX',
    alpha3Code: 'ALA',
    englishName: 'Åland Islands',
    flagEmoji: '🇦🇽',
    numericCode: '248',
  ),

  /// Albania
  albania(
    alpha2Code: 'AL',
    alpha3Code: 'ALB',
    englishName: 'Albania',
    flagEmoji: '🇦🇱',
    numericCode: '008',
  ),

  /// Algeria
  algeria(
    alpha2Code: 'DZ',
    alpha3Code: 'DZA',
    englishName: 'Algeria',
    flagEmoji: '🇩🇿',
    numericCode: '012',
  ),

  /// American Samoa
  americanSamoa(
    alpha2Code: 'AS',
    alpha3Code: 'ASM',
    englishName: 'American Samoa',
    flagEmoji: '🇦🇸',
    numericCode: '016',
  ),

  /// Andorra
  andorra(
    alpha2Code: 'AD',
    alpha3Code: 'AND',
    englishName: 'Andorra',
    flagEmoji: '🇦🇩',
    numericCode: '020',
  ),

  /// Angola
  angola(
    alpha2Code: 'AO',
    alpha3Code: 'AGO',
    englishName: 'Angola',
    flagEmoji: '🇦🇴',
    numericCode: '024',
  ),

  /// Anguilla
  anguilla(
    alpha2Code: 'AI',
    alpha3Code: 'AIA',
    englishName: 'Anguilla',
    flagEmoji: '🇦🇮',
    numericCode: '660',
  ),

  /// Antarctica
  antarctica(
    alpha2Code: 'AQ',
    alpha3Code: 'ATA',
    englishName: 'Antarctica',
    flagEmoji: '🇦🇶',
    numericCode: '010',
  ),

  /// Antigua and Barbuda
  antiguaAndBarbuda(
    alpha2Code: 'AG',
    alpha3Code: 'ATG',
    englishName: 'Antigua and Barbuda',
    flagEmoji: '🇦🇬',
    numericCode: '028',
  ),

  /// Argentina
  argentina(
    alpha2Code: 'AR',
    alpha3Code: 'ARG',
    englishName: 'Argentina',
    flagEmoji: '🇦🇷',
    numericCode: '032',
  ),

  /// Armenia
  armenia(
    alpha2Code: 'AM',
    alpha3Code: 'ARM',
    englishName: 'Armenia',
    flagEmoji: '🇦🇲',
    numericCode: '051',
  ),

  /// Aruba
  aruba(
    alpha2Code: 'AW',
    alpha3Code: 'ABW',
    englishName: 'Aruba',
    flagEmoji: '🇦🇼',
    numericCode: '533',
  ),

  /// Australia
  australia(
    alpha2Code: 'AU',
    alpha3Code: 'AUS',
    englishName: 'Australia',
    flagEmoji: '🇦🇺',
    numericCode: '036',
  ),

  /// Austria
  austria(
    alpha2Code: 'AT',
    alpha3Code: 'AUT',
    englishName: 'Austria',
    flagEmoji: '🇦🇹',
    numericCode: '040',
  ),

  /// Azerbaijan
  azerbaijan(
    alpha2Code: 'AZ',
    alpha3Code: 'AZE',
    englishName: 'Azerbaijan',
    flagEmoji: '🇦🇿',
    numericCode: '031',
  ),

  /// Bahamas
  bahamas(
    alpha2Code: 'BS',
    alpha3Code: 'BHS',
    englishName: 'Bahamas',
    flagEmoji: '🇧🇸',
    numericCode: '044',
  ),

  /// Bahrain
  bahrain(
    alpha2Code: 'BH',
    alpha3Code: 'BHR',
    englishName: 'Bahrain',
    flagEmoji: '🇧🇭',
    numericCode: '048',
  ),

  /// Bangladesh
  bangladesh(
    alpha2Code: 'BD',
    alpha3Code: 'BGD',
    englishName: 'Bangladesh',
    flagEmoji: '🇧🇩',
    numericCode: '050',
  ),

  /// Barbados
  barbados(
    alpha2Code: 'BB',
    alpha3Code: 'BRB',
    englishName: 'Barbados',
    flagEmoji: '🇧🇧',
    numericCode: '052',
  ),

  /// Belarus
  belarus(
    alpha2Code: 'BY',
    alpha3Code: 'BLR',
    englishName: 'Belarus',
    flagEmoji: '🇧🇾',
    numericCode: '112',
  ),

  /// Belgium
  belgium(
    alpha2Code: 'BE',
    alpha3Code: 'BEL',
    englishName: 'Belgium',
    flagEmoji: '🇧🇪',
    numericCode: '056',
  ),

  /// Belize
  belize(
    alpha2Code: 'BZ',
    alpha3Code: 'BLZ',
    englishName: 'Belize',
    flagEmoji: '🇧🇿',
    numericCode: '084',
  ),

  /// Benin
  benin(
    alpha2Code: 'BJ',
    alpha3Code: 'BEN',
    englishName: 'Benin',
    flagEmoji: '🇧🇯',
    numericCode: '204',
  ),

  /// Bermuda
  bermuda(
    alpha2Code: 'BM',
    alpha3Code: 'BMU',
    englishName: 'Bermuda',
    flagEmoji: '🇧🇲',
    numericCode: '060',
  ),

  /// Bhutan
  bhutan(
    alpha2Code: 'BT',
    alpha3Code: 'BTN',
    englishName: 'Bhutan',
    flagEmoji: '🇧🇹',
    numericCode: '064',
  ),

  /// Bolivia (Plurinational State of)
  bolivia(
    alpha2Code: 'BO',
    alpha3Code: 'BOL',
    englishName: 'Bolivia (Plurinational State of)',
    flagEmoji: '🇧🇴',
    numericCode: '068',
  ),

  /// Bonaire, Sint Eustatius and Saba
  bonaireSintEustatiusAndSaba(
    alpha2Code: 'BQ',
    alpha3Code: 'BES',
    englishName: 'Bonaire, Sint Eustatius and Saba',
    flagEmoji: '🇧🇶',
    numericCode: '535',
  ),

  /// BosniaAndHerzegovina
  bosniaAndHerzegovina(
    alpha2Code: 'BA',
    alpha3Code: 'BIH',
    englishName: 'Bosnia and Herzegovina',
    flagEmoji: '🇧🇦',
    numericCode: '070',
  ),

  /// Botswana
  botswana(
    alpha2Code: 'BW',
    alpha3Code: 'BWA',
    englishName: 'Botswana',
    flagEmoji: '🇧🇼',
    numericCode: '072',
  ),

  /// Bouvet Island
  bouvetIsland(
    alpha2Code: 'BV',
    alpha3Code: 'BVT',
    englishName: 'Bouvet Island',
    flagEmoji: '🇧🇻',
    numericCode: '074',
  ),

  /// Brazil
  brazil(
    alpha2Code: 'BR',
    alpha3Code: 'BRA',
    englishName: 'Brazil',
    flagEmoji: '🇧🇷',
    numericCode: '076',
  ),

  /// British Indian Ocean Territory
  britishIndianOceanTerritory(
    alpha2Code: 'IO',
    alpha3Code: 'IOT',
    englishName: 'British Indian Ocean Territory',
    flagEmoji: '🇮🇴',
    numericCode: '086',
  ),

  /// Brunei Darussalam
  bruneiDarussalam(
    alpha2Code: 'BN',
    alpha3Code: 'BRN',
    englishName: 'Brunei Darussalam',
    flagEmoji: '🇧🇳',
    numericCode: '096',
  ),

  /// Bulgaria
  bulgaria(
    alpha2Code: 'BG',
    alpha3Code: 'BGR',
    englishName: 'Bulgaria',
    flagEmoji: '🇧🇬',
    numericCode: '100',
  ),

  /// Burkina Faso
  burkinaFaso(
    alpha2Code: 'BF',
    alpha3Code: 'BFA',
    englishName: 'Burkina Faso',
    flagEmoji: '🇧🇫',
    numericCode: '854',
  ),

  /// Burundi
  burundi(
    alpha2Code: 'BI',
    alpha3Code: 'BDI',
    englishName: 'Burundi',
    flagEmoji: '🇧🇮',
    numericCode: '108',
  ),

  /// Cabo Verde
  caboVerde(
    alpha2Code: 'CV',
    alpha3Code: 'CPV',
    englishName: 'Cabo Verde',
    flagEmoji: '🇨🇻',
    numericCode: '132',
  ),

  /// Cambodia
  cambodia(
    alpha2Code: 'KH',
    alpha3Code: 'KHM',
    englishName: 'Cambodia',
    flagEmoji: '🇰🇭',
    numericCode: '116',
  ),

  /// Cameroon
  cameroon(
    alpha2Code: 'CM',
    alpha3Code: 'CMR',
    englishName: 'Cameroon',
    flagEmoji: '🇨🇲',
    numericCode: '120',
  ),

  /// Canada
  canada(
    alpha2Code: 'CA',
    alpha3Code: 'CAN',
    englishName: 'Canada',
    flagEmoji: '🇨🇦',
    numericCode: '124',
  ),

  /// Cayman Islands
  caymanIslands(
    alpha2Code: 'KY',
    alpha3Code: 'CYM',
    englishName: 'Cayman Islands',
    flagEmoji: '🇰🇾',
    numericCode: '136',
  ),

  /// Central African Republic
  centralAfricanRepublic(
    alpha2Code: 'CF',
    alpha3Code: 'CAF',
    englishName: 'Central African Republic',
    flagEmoji: '🇨🇫',
    numericCode: '140',
  ),

  /// Chad
  chad(
    alpha2Code: 'TD',
    alpha3Code: 'TCD',
    englishName: 'Chad',
    flagEmoji: '🇹🇩',
    numericCode: '148',
  ),

  /// Chile
  chile(
    alpha2Code: 'CL',
    alpha3Code: 'CHL',
    englishName: 'Chile',
    flagEmoji: '🇨🇱',
    numericCode: '152',
  ),

  /// China
  china(
    alpha2Code: 'CN',
    alpha3Code: 'CHN',
    englishName: 'China',
    flagEmoji: '🇨🇳',
    numericCode: '156',
  ),

  /// Christmas Island
  christmasIsland(
    alpha2Code: 'CX',
    alpha3Code: 'CXR',
    englishName: 'Christmas Island',
    flagEmoji: '🇨🇽',
    numericCode: '162',
  ),

  /// Cocos (Keeling) Islands
  cocosKeelingIslands(
    alpha2Code: 'CC',
    alpha3Code: 'CCK',
    englishName: 'Cocos (Keeling) Islands',
    flagEmoji: '🇨🇨',
    numericCode: '166',
  ),

  /// Colombia
  colombia(
    alpha2Code: 'CO',
    alpha3Code: 'COL',
    englishName: 'Colombia',
    flagEmoji: '🇨🇴',
    numericCode: '170',
  ),

  /// Comoros
  comoros(
    alpha2Code: 'KM',
    alpha3Code: 'COM',
    englishName: 'Comoros',
    flagEmoji: '🇰🇲',
    numericCode: '174',
  ),

  /// Congo (the Democratic Republic of the)
  congoDemocraticRepublic(
    alpha2Code: 'CD',
    alpha3Code: 'COD',
    englishName: 'Congo (the Democratic Republic of the)',
    flagEmoji: '🇨🇩',
    numericCode: '180',
  ),

  /// Congo
  congo(
    alpha2Code: 'CG',
    alpha3Code: 'COG',
    englishName: 'Congo',
    flagEmoji: '🇨🇬',
    numericCode: '178',
  ),

  /// Cook Islands
  cookIslands(
    alpha2Code: 'CK',
    alpha3Code: 'COK',
    englishName: 'Cook Islands',
    flagEmoji: '🇨🇰',
    numericCode: '184',
  ),

  /// Costa Rica
  costaRica(
    alpha2Code: 'CR',
    alpha3Code: 'CRI',
    englishName: 'Costa Rica',
    flagEmoji: '🇨🇷',
    numericCode: '188',
  ),

  /// Côte d’Ivoire
  coteDIvoire(
    alpha2Code: 'CI',
    alpha3Code: 'CIV',
    englishName: 'Côte d’Ivoire',
    flagEmoji: '🇨🇮',
    numericCode: '384',
  ),

  /// Croatia
  croatia(
    alpha2Code: 'HR',
    alpha3Code: 'HRV',
    englishName: 'Croatia',
    flagEmoji: '🇭🇷',
    numericCode: '191',
  ),

  /// Cuba
  cuba(
    alpha2Code: 'CU',
    alpha3Code: 'CUB',
    englishName: 'Cuba',
    flagEmoji: '🇨🇺',
    numericCode: '192',
  ),

  /// Curaçao
  curacao(
    alpha2Code: 'CW',
    alpha3Code: 'CUW',
    englishName: 'Curaçao',
    flagEmoji: '🇨🇼',
    numericCode: '531',
  ),

  /// Cyprus
  cyprus(
    alpha2Code: 'CY',
    alpha3Code: 'CYP',
    englishName: 'Cyprus',
    flagEmoji: '🇨🇾',
    numericCode: '196',
  ),

  /// Czechia
  czechia(
    alpha2Code: 'CZ',
    alpha3Code: 'CZE',
    englishName: 'Czechia',
    flagEmoji: '🇨🇿',
    numericCode: '203',
  ),

  /// Denmark
  denmark(
    alpha2Code: 'DK',
    alpha3Code: 'DNK',
    englishName: 'Denmark',
    flagEmoji: '🇩🇰',
    numericCode: '208',
  ),

  /// Djibouti
  djibouti(
    alpha2Code: 'DJ',
    alpha3Code: 'DJI',
    englishName: 'Djibouti',
    flagEmoji: '🇩🇯',
    numericCode: '262',
  ),

  /// Dominica
  dominica(
    alpha2Code: 'DM',
    alpha3Code: 'DMA',
    englishName: 'Dominica',
    flagEmoji: '🇩🇲',
    numericCode: '212',
  ),

  /// DominicanRepublic
  dominicanRepublic(
    alpha2Code: 'DO',
    alpha3Code: 'DOM',
    englishName: 'Dominican Republic',
    flagEmoji: '🇩🇴',
    numericCode: '214',
  ),

  /// Ecuador
  ecuador(
    alpha2Code: 'EC',
    alpha3Code: 'ECU',
    englishName: 'Ecuador',
    flagEmoji: '🇪🇨',
    numericCode: '218',
  ),

  /// Egypt
  egypt(
    alpha2Code: 'EG',
    alpha3Code: 'EGY',
    englishName: 'Egypt',
    flagEmoji: '🇪🇬',
    numericCode: '818',
  ),

  /// El Salvador
  elSalvador(
    alpha2Code: 'SV',
    alpha3Code: 'SLV',
    englishName: 'El Salvador',
    flagEmoji: '🇸🇻',
    numericCode: '222',
  ),

  /// Equatorial Guinea
  equatorialGuinea(
    alpha2Code: 'GQ',
    alpha3Code: 'GNQ',
    englishName: 'Equatorial Guinea',
    flagEmoji: '🇬🇶',
    numericCode: '226',
  ),

  /// Eritrea
  eritrea(
    alpha2Code: 'ER',
    alpha3Code: 'ERI',
    englishName: 'Eritrea',
    flagEmoji: '🇪🇷',
    numericCode: '232',
  ),

  /// Estonia
  estonia(
    alpha2Code: 'EE',
    alpha3Code: 'EST',
    englishName: 'Estonia',
    flagEmoji: '🇪🇪',
    numericCode: '233',
  ),

  /// Eswatini
  eswatini(
    alpha2Code: 'SZ',
    alpha3Code: 'SWZ',
    englishName: 'Eswatini',
    flagEmoji: '🇸🇿',
    numericCode: '748',
  ),

  /// Ethiopia
  ethiopia(
    alpha2Code: 'ET',
    alpha3Code: 'ETH',
    englishName: 'Ethiopia',
    flagEmoji: '🇪🇹',
    numericCode: '231',
  ),

  // ignore: comment_references
  /// Falkland Islands [Malvinas]
  falklandIslandsMalvinas(
    alpha2Code: 'FK',
    alpha3Code: 'FLK',
    englishName: 'Falkland Islands [Malvinas]',
    flagEmoji: '🇫🇰',
    numericCode: '238',
  ),

  /// Faroe Islands
  faroeIslands(
    alpha2Code: 'FO',
    alpha3Code: 'FRO',
    englishName: 'Faroe Islands',
    flagEmoji: '🇫🇴',
    numericCode: '234',
  ),

  /// Fiji
  fiji(
    alpha2Code: 'FJ',
    alpha3Code: 'FJI',
    englishName: 'Fiji',
    flagEmoji: '🇫🇯',
    numericCode: '242',
  ),

  /// Finland
  finland(
    alpha2Code: 'FI',
    alpha3Code: 'FIN',
    englishName: 'Finland',
    flagEmoji: '🇫🇮',
    numericCode: '246',
  ),

  /// France
  france(
    alpha2Code: 'FR',
    alpha3Code: 'FRA',
    englishName: 'France',
    flagEmoji: '🇫🇷',
    numericCode: '250',
  ),

  /// French Guiana
  frenchGuiana(
    alpha2Code: 'GF',
    alpha3Code: 'GUF',
    englishName: 'French Guiana',
    flagEmoji: '🇬🇫',
    numericCode: '254',
  ),

  /// French Polynesia
  frenchPolynesia(
    alpha2Code: 'PF',
    alpha3Code: 'PYF',
    englishName: 'French Polynesia',
    flagEmoji: '🇵🇫',
    numericCode: '258',
  ),

  /// French Southern Territories
  frenchSouthernTerritories(
    alpha2Code: 'TF',
    alpha3Code: 'ATF',
    englishName: 'French Southern Territories',
    flagEmoji: '🇹🇫',
    numericCode: '260',
  ),

  /// Gabon
  gabon(
    alpha2Code: 'GA',
    alpha3Code: 'GAB',
    englishName: 'Gabon',
    flagEmoji: '🇬🇦',
    numericCode: '266',
  ),

  /// Gambia
  gambia(
    alpha2Code: 'GM',
    alpha3Code: 'GMB',
    englishName: 'Gambia',
    flagEmoji: '🇬🇲',
    numericCode: '270',
  ),

  /// Georgia
  georgia(
    alpha2Code: 'GE',
    alpha3Code: 'GEO',
    englishName: 'Georgia',
    flagEmoji: '🇬🇪',
    numericCode: '268',
  ),

  /// Germany
  germany(
    alpha2Code: 'DE',
    alpha3Code: 'DEU',
    englishName: 'Germany',
    flagEmoji: '🇩🇪',
    numericCode: '276',
  ),

  /// Ghana
  ghana(
    alpha2Code: 'GH',
    alpha3Code: 'GHA',
    englishName: 'Ghana',
    flagEmoji: '🇬🇭',
    numericCode: '288',
  ),

  /// Gibraltar
  gibraltar(
    alpha2Code: 'GI',
    alpha3Code: 'GIB',
    englishName: 'Gibraltar',
    flagEmoji: '🇬🇮',
    numericCode: '292',
  ),

  /// Greece
  greece(
    alpha2Code: 'GR',
    alpha3Code: 'GRC',
    englishName: 'Greece',
    flagEmoji: '🇬🇷',
    numericCode: '300',
  ),

  /// Greenland
  greenland(
    alpha2Code: 'GL',
    alpha3Code: 'GRL',
    englishName: 'Greenland',
    flagEmoji: '🇬🇱',
    numericCode: '304',
  ),

  /// Grenada
  grenada(
    alpha2Code: 'GD',
    alpha3Code: 'GRD',
    englishName: 'Grenada',
    flagEmoji: '🇬🇩',
    numericCode: '308',
  ),

  /// Guadeloupe
  guadeloupe(
    alpha2Code: 'GP',
    alpha3Code: 'GLP',
    englishName: 'Guadeloupe',
    flagEmoji: '🇬🇵',
    numericCode: '312',
  ),

  /// Guam
  guam(
    alpha2Code: 'GU',
    alpha3Code: 'GUM',
    englishName: 'Guam',
    flagEmoji: '🇬🇺',
    numericCode: '316',
  ),

  /// Guatemala
  guatemala(
    alpha2Code: 'GT',
    alpha3Code: 'GTM',
    englishName: 'Guatemala',
    flagEmoji: '🇬🇹',
    numericCode: '320',
  ),

  /// Guernsey
  guernsey(
    alpha2Code: 'GG',
    alpha3Code: 'GGY',
    englishName: 'Guernsey',
    flagEmoji: '🇬🇬',
    numericCode: '831',
  ),

  /// Guinea-Bissau
  guineaBissau(
    alpha2Code: 'GW',
    alpha3Code: 'GNB',
    englishName: 'Guinea-Bissau',
    flagEmoji: '🇬🇼',
    numericCode: '624',
  ),

  /// Guinea
  guinea(
    alpha2Code: 'GN',
    alpha3Code: 'GIN',
    englishName: 'Guinea',
    flagEmoji: '🇬🇳',
    numericCode: '324',
  ),

  /// Guyana
  guyana(
    alpha2Code: 'GY',
    alpha3Code: 'GUY',
    englishName: 'Guyana',
    flagEmoji: '🇬🇾',
    numericCode: '328',
  ),

  /// Haiti
  haiti(
    alpha2Code: 'HT',
    alpha3Code: 'HTI',
    englishName: 'Haiti',
    flagEmoji: '🇭🇹',
    numericCode: '332',
  ),

  /// Heard Island and McDonald Islands
  heardIslandAndMcDonaldIslands(
    alpha2Code: 'HM',
    alpha3Code: 'HMD',
    englishName: 'Heard Island and McDonald Islands',
    flagEmoji: '🇭🇲',
    numericCode: '334',
  ),

  /// Holy See
  holySee(
    alpha2Code: 'VA',
    alpha3Code: 'VAT',
    englishName: 'Holy See',
    flagEmoji: '🇻🇦',
    numericCode: '336',
  ),

  /// Honduras
  honduras(
    alpha2Code: 'HN',
    alpha3Code: 'HND',
    englishName: 'Honduras',
    flagEmoji: '🇭🇳',
    numericCode: '340',
  ),

  /// Hong Kong
  hongKong(
    alpha2Code: 'HK',
    alpha3Code: 'HKG',
    englishName: 'Hong Kong',
    flagEmoji: '🇭🇰',
    numericCode: '344',
  ),

  /// Hungary
  hungary(
    alpha2Code: 'HU',
    alpha3Code: 'HUN',
    englishName: 'Hungary',
    flagEmoji: '🇭🇺',
    numericCode: '348',
  ),

  /// Iceland
  iceland(
    alpha2Code: 'IS',
    alpha3Code: 'ISL',
    englishName: 'Iceland',
    flagEmoji: '🇮🇸',
    numericCode: '352',
  ),

  /// India
  india(
    alpha2Code: 'IN',
    alpha3Code: 'IND',
    englishName: 'India',
    flagEmoji: '🇮🇳',
    numericCode: '356',
  ),

  /// Indonesia
  indonesia(
    alpha2Code: 'ID',
    alpha3Code: 'IDN',
    englishName: 'Indonesia',
    flagEmoji: '🇮🇩',
    numericCode: '360',
  ),

  /// Iran (Islamic Republic of)
  iran(
    alpha2Code: 'IR',
    alpha3Code: 'IRN',
    englishName: 'Iran (Islamic Republic of)',
    flagEmoji: '🇮🇷',
    numericCode: '364',
  ),

  /// Iraq
  iraq(
    alpha2Code: 'IQ',
    alpha3Code: 'IRQ',
    englishName: 'Iraq',
    flagEmoji: '🇮🇶',
    numericCode: '368',
  ),

  /// Ireland
  ireland(
    alpha2Code: 'IE',
    alpha3Code: 'IRL',
    englishName: 'Ireland',
    flagEmoji: '🇮🇪',
    numericCode: '372',
  ),

  /// Isle of Man
  isleOfMan(
    alpha2Code: 'IM',
    alpha3Code: 'IMN',
    englishName: 'Isle of Man',
    flagEmoji: '🇮🇲',
    numericCode: '833',
  ),

  /// Israel
  israel(
    alpha2Code: 'IL',
    alpha3Code: 'ISR',
    englishName: 'Israel',
    flagEmoji: '🇮🇱',
    numericCode: '376',
  ),

  /// Italy
  italy(
    alpha2Code: 'IT',
    alpha3Code: 'ITA',
    englishName: 'Italy',
    flagEmoji: '🇮🇹',
    numericCode: '380',
  ),

  /// Jamaica
  jamaica(
    alpha2Code: 'JM',
    alpha3Code: 'JAM',
    englishName: 'Jamaica',
    flagEmoji: '🇯🇲',
    numericCode: '388',
  ),

  /// Japan
  japan(
    alpha2Code: 'JP',
    alpha3Code: 'JPN',
    englishName: 'Japan',
    flagEmoji: '🇯🇵',
    numericCode: '392',
  ),

  /// Jersey
  jersey(
    alpha2Code: 'JE',
    alpha3Code: 'JEY',
    englishName: 'Jersey',
    flagEmoji: '🇯🇪',
    numericCode: '832',
  ),

  /// Jordan
  jordan(
    alpha2Code: 'JO',
    alpha3Code: 'JOR',
    englishName: 'Jordan',
    flagEmoji: '🇯🇴',
    numericCode: '400',
  ),

  /// Kazakhstan
  kazakhstan(
    alpha2Code: 'KZ',
    alpha3Code: 'KAZ',
    englishName: 'Kazakhstan',
    flagEmoji: '🇰🇿',
    numericCode: '398',
  ),

  /// Kenya
  kenya(
    alpha2Code: 'KE',
    alpha3Code: 'KEN',
    englishName: 'Kenya',
    flagEmoji: '🇰🇪',
    numericCode: '404',
  ),

  /// Kiribati
  kiribati(
    alpha2Code: 'KI',
    alpha3Code: 'KIR',
    englishName: 'Kiribati',
    flagEmoji: '🇰🇮',
    numericCode: '296',
  ),

  /// Korea (the Democratic People’s Republic of)
  koreaDemocraticPeoplesRepublic(
    alpha2Code: 'KP',
    alpha3Code: 'PRK',
    englishName: 'Korea (the Democratic People’s Republic of)',
    flagEmoji: '🇰🇵',
    numericCode: '408',
  ),

  /// Korea (the Republic of)
  korea(
    alpha2Code: 'KR',
    alpha3Code: 'KOR',
    englishName: 'Korea (the Republic of)',
    flagEmoji: '🇰🇷',
    numericCode: '410',
  ),

  /// Kuwait
  kuwait(
    alpha2Code: 'KW',
    alpha3Code: 'KWT',
    englishName: 'Kuwait',
    flagEmoji: '🇰🇼',
    numericCode: '414',
  ),

  /// Kyrgyzstan
  kyrgyzstan(
    alpha2Code: 'KG',
    alpha3Code: 'KGZ',
    englishName: 'Kyrgyzstan',
    flagEmoji: '🇰🇬',
    numericCode: '417',
  ),

  /// Lao People’s Democratic Republic
  laoPeoplesDemocraticRepublic(
    alpha2Code: 'LA',
    alpha3Code: 'LAO',
    englishName: 'Lao People’s Democratic Republic',
    flagEmoji: '🇱🇦',
    numericCode: '418',
  ),

  /// Latvia
  latvia(
    alpha2Code: 'LV',
    alpha3Code: 'LVA',
    englishName: 'Latvia',
    flagEmoji: '🇱🇻',
    numericCode: '428',
  ),

  /// Lebanon
  lebanon(
    alpha2Code: 'LB',
    alpha3Code: 'LBN',
    englishName: 'Lebanon',
    flagEmoji: '🇱🇧',
    numericCode: '422',
  ),

  /// Lesotho
  lesotho(
    alpha2Code: 'LS',
    alpha3Code: 'LSO',
    englishName: 'Lesotho',
    flagEmoji: '🇱🇸',
    numericCode: '426',
  ),

  /// Liberia
  liberia(
    alpha2Code: 'LR',
    alpha3Code: 'LBR',
    englishName: 'Liberia',
    flagEmoji: '🇱🇷',
    numericCode: '430',
  ),

  /// Libya
  libya(
    alpha2Code: 'LY',
    alpha3Code: 'LBY',
    englishName: 'Libya',
    flagEmoji: '🇱🇾',
    numericCode: '434',
  ),

  /// Liechtenstein
  liechtenstein(
    alpha2Code: 'LI',
    alpha3Code: 'LIE',
    englishName: 'Liechtenstein',
    flagEmoji: '🇱🇮',
    numericCode: '438',
  ),

  /// Lithuania
  lithuania(
    alpha2Code: 'LT',
    alpha3Code: 'LTU',
    englishName: 'Lithuania',
    flagEmoji: '🇱🇹',
    numericCode: '440',
  ),

  /// Luxembourg
  luxembourg(
    alpha2Code: 'LU',
    alpha3Code: 'LUX',
    englishName: 'Luxembourg',
    flagEmoji: '🇱🇺',
    numericCode: '442',
  ),

  /// Macao
  macao(
    alpha2Code: 'MO',
    alpha3Code: 'MAC',
    englishName: 'Macao',
    flagEmoji: '🇲🇴',
    numericCode: '446',
  ),

  /// Madagascar
  madagascar(
    alpha2Code: 'MG',
    alpha3Code: 'MDG',
    englishName: 'Madagascar',
    flagEmoji: '🇲🇬',
    numericCode: '450',
  ),

  /// Malawi
  malawi(
    alpha2Code: 'MW',
    alpha3Code: 'MWI',
    englishName: 'Malawi',
    flagEmoji: '🇲🇼',
    numericCode: '454',
  ),

  /// Malaysia
  malaysia(
    alpha2Code: 'MY',
    alpha3Code: 'MYS',
    englishName: 'Malaysia',
    flagEmoji: '🇲🇾',
    numericCode: '458',
  ),

  /// Maldives
  maldives(
    alpha2Code: 'MV',
    alpha3Code: 'MDV',
    englishName: 'Maldives',
    flagEmoji: '🇲🇻',
    numericCode: '462',
  ),

  /// Mali
  mali(
    alpha2Code: 'ML',
    alpha3Code: 'MLI',
    englishName: 'Mali',
    flagEmoji: '🇲🇱',
    numericCode: '466',
  ),

  /// Malta
  malta(
    alpha2Code: 'MT',
    alpha3Code: 'MLT',
    englishName: 'Malta',
    flagEmoji: '🇲🇹',
    numericCode: '470',
  ),

  /// Marshall Islands
  marshallIslands(
    alpha2Code: 'MH',
    alpha3Code: 'MHL',
    englishName: 'Marshall Islands',
    flagEmoji: '🇲🇭',
    numericCode: '584',
  ),

  /// Martinique
  martinique(
    alpha2Code: 'MQ',
    alpha3Code: 'MTQ',
    englishName: 'Martinique',
    flagEmoji: '🇲🇶',
    numericCode: '474',
  ),

  /// Mauritania
  mauritania(
    alpha2Code: 'MR',
    alpha3Code: 'MRT',
    englishName: 'Mauritania',
    flagEmoji: '🇲🇷',
    numericCode: '478',
  ),

  /// Mauritius
  mauritius(
    alpha2Code: 'MU',
    alpha3Code: 'MUS',
    englishName: 'Mauritius',
    flagEmoji: '🇲🇺',
    numericCode: '480',
  ),

  /// Mayotte
  mayotte(
    alpha2Code: 'YT',
    alpha3Code: 'MYT',
    englishName: 'Mayotte',
    flagEmoji: '🇾🇹',
    numericCode: '175',
  ),

  /// Mexico
  mexico(
    alpha2Code: 'MX',
    alpha3Code: 'MEX',
    englishName: 'Mexico',
    flagEmoji: '🇲🇽',
    numericCode: '484',
  ),

  /// Micronesia (Federated States of)
  micronesia(
    alpha2Code: 'FM',
    alpha3Code: 'FSM',
    englishName: 'Micronesia (Federated States of)',
    flagEmoji: '🇫🇲',
    numericCode: '583',
  ),

  /// Moldova (the Republic of)
  moldova(
    alpha2Code: 'MD',
    alpha3Code: 'MDA',
    englishName: 'Moldova (the Republic of)',
    flagEmoji: '🇲🇩',
    numericCode: '498',
  ),

  /// Monaco
  monaco(
    alpha2Code: 'MC',
    alpha3Code: 'MCO',
    englishName: 'Monaco',
    flagEmoji: '🇲🇨',
    numericCode: '492',
  ),

  /// Mongolia
  mongolia(
    alpha2Code: 'MN',
    alpha3Code: 'MNG',
    englishName: 'Mongolia',
    flagEmoji: '🇲🇳',
    numericCode: '496',
  ),

  /// Montenegro
  montenegro(
    alpha2Code: 'ME',
    alpha3Code: 'MNE',
    englishName: 'Montenegro',
    flagEmoji: '🇲🇪',
    numericCode: '499',
  ),

  /// Montserrat
  montserrat(
    alpha2Code: 'MS',
    alpha3Code: 'MSR',
    englishName: 'Montserrat',
    flagEmoji: '🇲🇸',
    numericCode: '500',
  ),

  /// Morocco
  morocco(
    alpha2Code: 'MA',
    alpha3Code: 'MAR',
    englishName: 'Morocco',
    flagEmoji: '🇲🇦',
    numericCode: '504',
  ),

  /// Mozambique
  mozambique(
    alpha2Code: 'MZ',
    alpha3Code: 'MOZ',
    englishName: 'Mozambique',
    flagEmoji: '🇲🇿',
    numericCode: '508',
  ),

  /// Myanmar
  myanmar(
    alpha2Code: 'MM',
    alpha3Code: 'MMR',
    englishName: 'Myanmar',
    flagEmoji: '🇲🇲',
    numericCode: '104',
  ),

  /// Namibia
  namibia(
    alpha2Code: 'NA',
    alpha3Code: 'NAM',
    englishName: 'Namibia',
    flagEmoji: '🇳🇦',
    numericCode: '516',
  ),

  /// Nauru
  nauru(
    alpha2Code: 'NR',
    alpha3Code: 'NRU',
    englishName: 'Nauru',
    flagEmoji: '🇳🇷',
    numericCode: '520',
  ),

  /// Nepal
  nepal(
    alpha2Code: 'NP',
    alpha3Code: 'NPL',
    englishName: 'Nepal',
    flagEmoji: '🇳🇵',
    numericCode: '524',
  ),

  /// Netherlands
  netherlands(
    alpha2Code: 'NL',
    alpha3Code: 'NLD',
    englishName: 'Netherlands',
    flagEmoji: '🇳🇱',
    numericCode: '528',
  ),

  /// New Caledonia
  newCaledonia(
    alpha2Code: 'NC',
    alpha3Code: 'NCL',
    englishName: 'New Caledonia',
    flagEmoji: '🇳🇨',
    numericCode: '540',
  ),

  /// New Zealand
  newZealand(
    alpha2Code: 'NZ',
    alpha3Code: 'NZL',
    englishName: 'New Zealand',
    flagEmoji: '🇳🇿',
    numericCode: '554',
  ),

  /// Nicaragua
  nicaragua(
    alpha2Code: 'NI',
    alpha3Code: 'NIC',
    englishName: 'Nicaragua',
    flagEmoji: '🇳🇮',
    numericCode: '558',
  ),

  /// Niger
  niger(
    alpha2Code: 'NE',
    alpha3Code: 'NER',
    englishName: 'Niger',
    flagEmoji: '🇳🇪',
    numericCode: '562',
  ),

  /// Nigeria
  nigeria(
    alpha2Code: 'NG',
    alpha3Code: 'NGA',
    englishName: 'Nigeria',
    flagEmoji: '🇳🇬',
    numericCode: '566',
  ),

  /// Niue
  niue(
    alpha2Code: 'NU',
    alpha3Code: 'NIU',
    englishName: 'Niue',
    flagEmoji: '🇳🇺',
    numericCode: '570',
  ),

  /// Norfolk Island
  norfolkIsland(
    alpha2Code: 'NF',
    alpha3Code: 'NFK',
    englishName: 'Norfolk Island',
    flagEmoji: '🇳🇫',
    numericCode: '574',
  ),

  /// North Macedonia
  northMacedonia(
    alpha2Code: 'MK',
    alpha3Code: 'MKD',
    englishName: 'North Macedonia',
    flagEmoji: '🇲🇰',
    numericCode: '807',
  ),

  /// Northern Mariana Islands
  northernMarianaIslands(
    alpha2Code: 'MP',
    alpha3Code: 'MNP',
    englishName: 'Northern Mariana Islands',
    flagEmoji: '🇲🇵',
    numericCode: '580',
  ),

  /// Norway
  norway(
    alpha2Code: 'NO',
    alpha3Code: 'NOR',
    englishName: 'Norway',
    flagEmoji: '🇳🇴',
    numericCode: '578',
  ),

  /// Oman
  oman(
    alpha2Code: 'OM',
    alpha3Code: 'OMN',
    englishName: 'Oman',
    flagEmoji: '🇴🇲',
    numericCode: '512',
  ),

  /// Pakistan
  pakistan(
    alpha2Code: 'PK',
    alpha3Code: 'PAK',
    englishName: 'Pakistan',
    flagEmoji: '🇵🇰',
    numericCode: '586',
  ),

  /// Palau
  palau(
    alpha2Code: 'PW',
    alpha3Code: 'PLW',
    englishName: 'Palau',
    flagEmoji: '🇵🇼',
    numericCode: '585',
  ),

  /// Palestine, State of
  palestine(
    alpha2Code: 'PS',
    alpha3Code: 'PSE',
    englishName: 'Palestine, State of',
    flagEmoji: '🇵🇸',
    numericCode: '275',
  ),

  /// Panama
  panama(
    alpha2Code: 'PA',
    alpha3Code: 'PAN',
    englishName: 'Panama',
    flagEmoji: '🇵🇦',
    numericCode: '591',
  ),

  /// Papua New Guinea
  papuaNewGuinea(
    alpha2Code: 'PG',
    alpha3Code: 'PNG',
    englishName: 'Papua New Guinea',
    flagEmoji: '🇵🇬',
    numericCode: '598',
  ),

  /// Paraguay
  paraguay(
    alpha2Code: 'PY',
    alpha3Code: 'PRY',
    englishName: 'Paraguay',
    flagEmoji: '🇵🇾',
    numericCode: '600',
  ),

  /// Peru
  peru(
    alpha2Code: 'PE',
    alpha3Code: 'PER',
    englishName: 'Peru',
    flagEmoji: '🇵🇪',
    numericCode: '604',
  ),

  /// Philippines
  philippines(
    alpha2Code: 'PH',
    alpha3Code: 'PHL',
    englishName: 'Philippines',
    flagEmoji: '🇵🇭',
    numericCode: '608',
  ),

  /// Pitcairn
  pitcairn(
    alpha2Code: 'PN',
    alpha3Code: 'PCN',
    englishName: 'Pitcairn',
    flagEmoji: '🇵🇳',
    numericCode: '612',
  ),

  /// Poland
  poland(
    alpha2Code: 'PL',
    alpha3Code: 'POL',
    englishName: 'Poland',
    flagEmoji: '🇵🇱',
    numericCode: '616',
  ),

  /// Portugal
  portugal(
    alpha2Code: 'PT',
    alpha3Code: 'PRT',
    englishName: 'Portugal',
    flagEmoji: '🇵🇹',
    numericCode: '620',
  ),

  /// Puerto Rico
  puertoRico(
    alpha2Code: 'PR',
    alpha3Code: 'PRI',
    englishName: 'Puerto Rico',
    flagEmoji: '🇵🇷',
    numericCode: '630',
  ),

  /// Qatar
  qatar(
    alpha2Code: 'QA',
    alpha3Code: 'QAT',
    englishName: 'Qatar',
    flagEmoji: '🇶🇦',
    numericCode: '634',
  ),

  /// Reunion
  reunion(
    alpha2Code: 'RE',
    alpha3Code: 'REU',
    englishName: 'Réunion',
    flagEmoji: '🇷🇪',
    numericCode: '638',
  ),

  /// Romania
  romania(
    alpha2Code: 'RO',
    alpha3Code: 'ROU',
    englishName: 'Romania',
    flagEmoji: '🇷🇴',
    numericCode: '642',
  ),

  /// Russian Federation
  russianFederation(
    alpha2Code: 'RU',
    alpha3Code: 'RUS',
    englishName: 'Russian Federation',
    flagEmoji: '🇷🇺',
    numericCode: '643',
  ),

  /// Rwanda
  rwanda(
    alpha2Code: 'RW',
    alpha3Code: 'RWA',
    englishName: 'Rwanda',
    flagEmoji: '🇷🇼',
    numericCode: '646',
  ),

  /// Saint Barthelemy
  saintBarthelemy(
    alpha2Code: 'BL',
    alpha3Code: 'BLM',
    englishName: 'Saint Barthélemy',
    flagEmoji: '🇧🇱',
    numericCode: '652',
  ),

  /// Saint Helena, Ascension and Tristan da Cunha
  saintHelenaAscensionAndTristanDaCunha(
    alpha2Code: 'SH',
    alpha3Code: 'SHN',
    englishName: 'Saint Helena, Ascension and Tristan da Cunha',
    flagEmoji: '🇸🇭',
    numericCode: '654',
  ),

  /// Saint Kitts and Nevis
  saintKittsAndNevis(
    alpha2Code: 'KN',
    alpha3Code: 'KNA',
    englishName: 'Saint Kitts and Nevis',
    flagEmoji: '🇰🇳',
    numericCode: '659',
  ),

  /// Saint Lucia
  saintLucia(
    alpha2Code: 'LC',
    alpha3Code: 'LCA',
    englishName: 'Saint Lucia',
    flagEmoji: '🇱🇨',
    numericCode: '662',
  ),

  /// Saint Martin (French part)
  saintMartinFrenchPart(
    alpha2Code: 'MF',
    alpha3Code: 'MAF',
    englishName: 'Saint Martin (French part)',
    flagEmoji: '🇲🇫',
    numericCode: '663',
  ),

  /// Saint Pierre and Miquelon
  saintPierreAndMiquelon(
    alpha2Code: 'PM',
    alpha3Code: 'SPM',
    englishName: 'Saint Pierre and Miquelon',
    flagEmoji: '🇵🇲',
    numericCode: '666',
  ),

  /// Saint Vincent and the Grenadines
  saintVincentAndTheGrenadines(
    alpha2Code: 'VC',
    alpha3Code: 'VCT',
    englishName: 'Saint Vincent and the Grenadines',
    flagEmoji: '🇻🇨',
    numericCode: '670',
  ),

  /// Samoa
  samoa(
    alpha2Code: 'WS',
    alpha3Code: 'WSM',
    englishName: 'Samoa',
    flagEmoji: '🇼🇸',
    numericCode: '882',
  ),

  /// San Marino
  sanMarino(
    alpha2Code: 'SM',
    alpha3Code: 'SMR',
    englishName: 'San Marino',
    flagEmoji: '🇸🇲',
    numericCode: '674',
  ),

  /// Sao Tome and Principe
  saoTomeAndPrincipe(
    alpha2Code: 'ST',
    alpha3Code: 'STP',
    englishName: 'Sao Tome and Principe',
    flagEmoji: '🇸🇹',
    numericCode: '678',
  ),

  /// Saudi Arabia
  saudiArabia(
    alpha2Code: 'SA',
    alpha3Code: 'SAU',
    englishName: 'Saudi Arabia',
    flagEmoji: '🇸🇦',
    numericCode: '682',
  ),

  /// Senegal
  senegal(
    alpha2Code: 'SN',
    alpha3Code: 'SEN',
    englishName: 'Senegal',
    flagEmoji: '🇸🇳',
    numericCode: '686',
  ),

  /// Serbia
  serbia(
    alpha2Code: 'RS',
    alpha3Code: 'SRB',
    englishName: 'Serbia',
    flagEmoji: '🇷🇸',
    numericCode: '688',
  ),

  /// Seychelles
  seychelles(
    alpha2Code: 'SC',
    alpha3Code: 'SYC',
    englishName: 'Seychelles',
    flagEmoji: '🇸🇨',
    numericCode: '690',
  ),

  /// Sierra Leone
  sierraLeone(
    alpha2Code: 'SL',
    alpha3Code: 'SLE',
    englishName: 'Sierra Leone',
    flagEmoji: '🇸🇱',
    numericCode: '694',
  ),

  /// Singapore
  singapore(
    alpha2Code: 'SG',
    alpha3Code: 'SGP',
    englishName: 'Singapore',
    flagEmoji: '🇸🇬',
    numericCode: '702',
  ),

  /// Sint Maarten (Dutch part)
  sintMaartenDutchPart(
    alpha2Code: 'SX',
    alpha3Code: 'SXM',
    englishName: 'Sint Maarten (Dutch part)',
    flagEmoji: '🇸🇽',
    numericCode: '534',
  ),

  /// Slovakia
  slovakia(
    alpha2Code: 'SK',
    alpha3Code: 'SVK',
    englishName: 'Slovakia',
    flagEmoji: '🇸🇰',
    numericCode: '703',
  ),

  /// Slovenia
  slovenia(
    alpha2Code: 'SI',
    alpha3Code: 'SVN',
    englishName: 'Slovenia',
    flagEmoji: '🇸🇮',
    numericCode: '705',
  ),

  /// Solomon Islands
  solomonIslands(
    alpha2Code: 'SB',
    alpha3Code: 'SLB',
    englishName: 'Solomon Islands',
    flagEmoji: '🇸🇧',
    numericCode: '090',
  ),

  /// Somalia
  somalia(
    alpha2Code: 'SO',
    alpha3Code: 'SOM',
    englishName: 'Somalia',
    flagEmoji: '🇸🇴',
    numericCode: '706',
  ),

  /// South Africa
  southAfrica(
    alpha2Code: 'ZA',
    alpha3Code: 'ZAF',
    englishName: 'South Africa',
    flagEmoji: '🇿🇦',
    numericCode: '710',
  ),

  /// South Georgia and the South Sandwich Islands
  southGeorgiaAndTheSouthSandwichIslands(
    alpha2Code: 'GS',
    alpha3Code: 'SGS',
    englishName: 'South Georgia and the South Sandwich Islands',
    flagEmoji: '🇬🇸',
    numericCode: '239',
  ),

  /// South Sudan
  southSudan(
    alpha2Code: 'SS',
    alpha3Code: 'SSD',
    englishName: 'South Sudan',
    flagEmoji: '🇸🇸',
    numericCode: '728',
  ),

  /// Spain
  spain(
    alpha2Code: 'ES',
    alpha3Code: 'ESP',
    englishName: 'Spain',
    flagEmoji: '🇪🇸',
    numericCode: '724',
  ),

  /// Sri Lanka
  sriLanka(
    alpha2Code: 'LK',
    alpha3Code: 'LKA',
    englishName: 'Sri Lanka',
    flagEmoji: '🇱🇰',
    numericCode: '144',
  ),

  /// Sudan
  sudan(
    alpha2Code: 'SD',
    alpha3Code: 'SDN',
    englishName: 'Sudan',
    flagEmoji: '🇸🇩',
    numericCode: '729',
  ),

  /// Suriname
  suriname(
    alpha2Code: 'SR',
    alpha3Code: 'SUR',
    englishName: 'Suriname',
    flagEmoji: '🇸🇷',
    numericCode: '740',
  ),

  /// Svalbard and Jan Mayen
  svalbardAndJanMayen(
    alpha2Code: 'SJ',
    alpha3Code: 'SJM',
    englishName: 'Svalbard and Jan Mayen',
    flagEmoji: '🇸🇯',
    numericCode: '744',
  ),

  /// Sweden
  sweden(
    alpha2Code: 'SE',
    alpha3Code: 'SWE',
    englishName: 'Sweden',
    flagEmoji: '🇸🇪',
    numericCode: '752',
  ),

  /// Switzerland
  switzerland(
    alpha2Code: 'CH',
    alpha3Code: 'CHE',
    englishName: 'Switzerland',
    flagEmoji: '🇨🇭',
    numericCode: '756',
  ),

  /// Syrian Arab Republic
  syrianArabRepublic(
    alpha2Code: 'SY',
    alpha3Code: 'SYR',
    englishName: 'Syrian Arab Republic',
    flagEmoji: '🇸🇾',
    numericCode: '760',
  ),

  /// Taiwan (Province of China)
  taiwan(
    alpha2Code: 'TW',
    alpha3Code: 'TWN',
    englishName: 'Taiwan (Province of China)',
    flagEmoji: '🇹🇼',
    numericCode: '158',
  ),

  /// Tajikistan
  tajikistan(
    alpha2Code: 'TJ',
    alpha3Code: 'TJK',
    englishName: 'Tajikistan',
    flagEmoji: '🇹🇯',
    numericCode: '762',
  ),

  /// Tanzania, The United Republic of
  tanzania(
    alpha2Code: 'TZ',
    alpha3Code: 'TZA',
    englishName: 'Tanzania, The United Republic of',
    flagEmoji: '🇹🇿',
    numericCode: '834',
  ),

  /// Thailand
  thailand(
    alpha2Code: 'TH',
    alpha3Code: 'THA',
    englishName: 'Thailand',
    flagEmoji: '🇹🇭',
    numericCode: '764',
  ),

  /// Timor-Leste
  timorLeste(
    alpha2Code: 'TL',
    alpha3Code: 'TLS',
    englishName: 'Timor-Leste',
    flagEmoji: '🇹🇱',
    numericCode: '626',
  ),

  /// Togo
  togo(
    alpha2Code: 'TG',
    alpha3Code: 'TGO',
    englishName: 'Togo',
    flagEmoji: '🇹🇬',
    numericCode: '768',
  ),

  /// Tokelau
  tokelau(
    alpha2Code: 'TK',
    alpha3Code: 'TKL',
    englishName: 'Tokelau',
    flagEmoji: '🇹🇰',
    numericCode: '772',
  ),

  /// Tonga
  tonga(
    alpha2Code: 'TO',
    alpha3Code: 'TON',
    englishName: 'Tonga',
    flagEmoji: '🇹🇴',
    numericCode: '776',
  ),

  /// Trinidad and Tobago
  trinidadAndTobago(
    alpha2Code: 'TT',
    alpha3Code: 'TTO',
    englishName: 'Trinidad and Tobago',
    flagEmoji: '🇹🇹',
    numericCode: '780',
  ),

  /// Tunisia
  tunisia(
    alpha2Code: 'TN',
    alpha3Code: 'TUN',
    englishName: 'Tunisia',
    flagEmoji: '🇹🇳',
    numericCode: '788',
  ),

  /// Turkey
  turkey(
    alpha2Code: 'TR',
    alpha3Code: 'TUR',
    englishName: 'Turkey',
    flagEmoji: '🇹🇷',
    numericCode: '792',
  ),

  /// Turkmenistan
  turkmenistan(
    alpha2Code: 'TM',
    alpha3Code: 'TKM',
    englishName: 'Turkmenistan',
    flagEmoji: '🇹🇲',
    numericCode: '795',
  ),

  /// Turks and Caicos Islands
  turksAndCaicosIslands(
    alpha2Code: 'TC',
    alpha3Code: 'TCA',
    englishName: 'Turks and Caicos Islands',
    flagEmoji: '🇹🇨',
    numericCode: '796',
  ),

  /// Tuvalu
  tuvalu(
    alpha2Code: 'TV',
    alpha3Code: 'TUV',
    englishName: 'Tuvalu',
    flagEmoji: '🇹🇻',
    numericCode: '798',
  ),

  /// Uganda
  uganda(
    alpha2Code: 'UG',
    alpha3Code: 'UGA',
    englishName: 'Uganda',
    flagEmoji: '🇺🇬',
    numericCode: '800',
  ),

  /// Ukraine
  ukraine(
    alpha2Code: 'UA',
    alpha3Code: 'UKR',
    englishName: 'Ukraine',
    flagEmoji: '🇺🇦',
    numericCode: '804',
  ),

  /// United Arab Emirates
  unitedArabEmirates(
    alpha2Code: 'AE',
    alpha3Code: 'ARE',
    englishName: 'United Arab Emirates',
    flagEmoji: '🇦🇪',
    numericCode: '784',
  ),

  /// United Kingdom of Great Britain and Northern Ireland
  unitedKingdomOfGreatBritainAndNorthernIrelan(
    alpha2Code: 'GB',
    alpha3Code: 'GBR',
    englishName: 'United Kingdom of Great Britain and Northern Ireland',
    flagEmoji: '🇬🇧',
    numericCode: '826',
  ),

  /// United States Minor Outlying Islands
  unitedStatesMinorOutlyingIslands(
    alpha2Code: 'UM',
    alpha3Code: 'UMI',
    englishName: 'United States Minor Outlying Islands',
    flagEmoji: '🇺🇲',
    numericCode: '581',
  ),

  /// United States of America
  unitedStatesOfAmerica(
    alpha2Code: 'US',
    alpha3Code: 'USA',
    englishName: 'United States of America',
    flagEmoji: '🇺🇸',
    numericCode: '840',
  ),

  /// Uruguay
  uruguay(
    alpha2Code: 'UY',
    alpha3Code: 'URY',
    englishName: 'Uruguay',
    flagEmoji: '🇺🇾',
    numericCode: '858',
  ),

  /// Uzbekistan
  uzbekistan(
    alpha2Code: 'UZ',
    alpha3Code: 'UZB',
    englishName: 'Uzbekistan',
    flagEmoji: '🇺🇿',
    numericCode: '860',
  ),

  /// Vanuatu
  vanuatu(
    alpha2Code: 'VU',
    alpha3Code: 'VUT',
    englishName: 'Vanuatu',
    flagEmoji: '🇻🇺',
    numericCode: '548',
  ),

  /// Venezuela (Bolivarian Republic of)
  venezuela(
    alpha2Code: 'VE',
    alpha3Code: 'VEN',
    englishName: 'Venezuela (Bolivarian Republic of)',
    flagEmoji: '🇻🇪',
    numericCode: '862',
  ),

  /// Viet Nam
  vietNam(
    alpha2Code: 'VN',
    alpha3Code: 'VNM',
    englishName: 'Viet Nam',
    flagEmoji: '🇻🇳',
    numericCode: '704',
  ),

  /// Virgin Islands (British)
  virginIslandsBritish(
    alpha2Code: 'VG',
    alpha3Code: 'VGB',
    englishName: 'Virgin Islands (British)',
    flagEmoji: '🇻🇬',
    numericCode: '092',
  ),

  /// Virgin Islands (U.S.)
  virginIslandsUS(
    alpha2Code: 'VI',
    alpha3Code: 'VIR',
    englishName: 'Virgin Islands (U.S.)',
    flagEmoji: '🇻🇮',
    numericCode: '850',
  ),

  /// Wallis and Futuna
  wallisAndFutuna(
    alpha2Code: 'WF',
    alpha3Code: 'WLF',
    englishName: 'Wallis and Futuna',
    flagEmoji: '🇼🇫',
    numericCode: '876',
  ),

  /// Western Sahara
  westernSahara(
    alpha2Code: 'EH',
    alpha3Code: 'ESH',
    englishName: 'Western Sahara',
    flagEmoji: '🇪🇭',
    numericCode: '732',
  ),

  /// Yemen
  yemen(
    alpha2Code: 'YE',
    alpha3Code: 'YEM',
    englishName: 'Yemen',
    flagEmoji: '🇾🇪',
    numericCode: '887',
  ),

  /// Zambia
  zambia(
    alpha2Code: 'ZM',
    alpha3Code: 'ZMB',
    englishName: 'Zambia',
    flagEmoji: '🇿🇲',
    numericCode: '894',
  ),

  /// Zimbabwe
  zimbabwe(
    alpha2Code: 'ZW',
    alpha3Code: 'ZWE',
    englishName: 'Zimbabwe',
    flagEmoji: '🇿🇼',
    numericCode: '716',
  );

  /// Constructs a [Country] instance.
  ///
  const Country({
    required this.alpha2Code,
    required this.alpha3Code,
    required this.englishName,
    required this.flagEmoji,
    required this.numericCode,
  });

  /// Constructs a [Country] instance starting from a *correctly formatted
  /// string*.
  ///
  /// This constructor is *not case sensitive* and *does not take into account
  /// leading and trailing white spaces*.
  ///
  /// Throws a [FormatException] if the [formattedString] does not contain a
  /// valid representation of a [Country].
  ///
  /// Any string that coincides with the properties [alpha2Code], [alpha3Code],
  /// [englishName], [flagEmoji] and [numericCode] of one of the possible
  /// [Country] instances are valid and unique representations.
  ///
  /// Examples:
  ///
  /// ```dart
  /// Country.parse('SC'); // Country.seychelles
  /// Country.parse('sc'); // Country.seychelles
  /// Country.parse(' sc '); // Country.seychelles
  ///
  /// Country.parse('PRY'); // Country.paraguay
  /// Country.parse('pry'); // Country.paraguay
  /// Country.parse(' pry '); // Country.paraguay
  ///
  /// Country.parse('Åland Islands'); // Country.alandIslands
  /// Country.parse('åland islands'); // Country.alandIslands
  /// Country.parse(' åland islands '); // Country.alandIslands
  ///
  /// Country.parse('🇦🇶'); // Country.antarctica
  /// Country.parse(' 🇦🇶 '); // Country.antarctica
  ///
  /// Country.parse('184'); // Country.cookIslands
  /// Country.parse(' 184 '); // Country.cookIslands
  ///
  /// Country.parse(''); // Throws FormatException
  /// Country.parse('1234'); // Throws FormatException
  /// Country.parse('.'); // Throws FormatException
  /// ```
  ///
  factory Country.parse(final String formattedString) {
    final String lowerTrimmed = formattedString.toLowerCase().trim();
    for (final Country country in Country.values) {
      if (lowerTrimmed == country.alpha2Code.toLowerCase() ||
          lowerTrimmed == country.alpha3Code.toLowerCase() ||
          lowerTrimmed == country.englishName.toLowerCase() ||
          lowerTrimmed == country.flagEmoji ||
          lowerTrimmed == country.numericCode) {
        return country;
      }
    }
    throw FormatException(
      'This string ($formattedString) does not contain a valid and unique'
      ' representation of a [Country] instance.',
    );
  }

  /// The **2-letter code** (“alpha-2”), which is recommended as the
  /// general-purpose code.
  final String alpha2Code;

  /// The **3-letter code** (“alpha-3”), which is more closely related to the
  /// country name.
  final String alpha3Code;

  /// The **name** in English.
  final String englishName;

  /// The **emoji** of the **flag**.
  final String flagEmoji;

  /// The **3-digit numeric code** (“numeric-3”) which can be useful if you need
  /// to avoid using Latin script.
  final String numericCode;

  /// Returns a string representation of this [Country] value.
  ///
  /// This string coincides with [englishName] property of this instance of
  /// [Country].
  ///
  /// The resulting string can be parsed back using [Country.parse].
  ///
  /// Examples:
  ///
  /// ```dart
  /// Country.cocosKeelingIslands.toString(); // 'Cocos (Keeling) Islands'
  /// Country.haiti.toString(); // 'Haiti'
  /// Country.portugal.toString(); // 'Portugal'
  ///
  /// Country.parse(Country.andorra.toString()); // Country.andorra
  /// Country.parse(Country.gambia.toString()); // Country.gambia
  /// Country.parse(Country.vanuatu.toString()); // Country.vanuatu
  /// ```
  ///
  @override
  String toString() => englishName;
}
